Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4901)
+++ palm/trunk/SOURCE/modules.f90	(revision 1)
@@ -1464,119 +842,280 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of variables which define processor topology and the exchange of ghost point layers.
-!> This module must be placed in all routines containing MPI-calls.
-!--------------------------------------------------------------------------------------------------!
+
+
+ MODULE model_1d
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of variables for the 1D-model
+!------------------------------------------------------------------------------!
+
+    INTEGER ::  current_timestep_number_1d = 0, damp_level_ind_1d, &
+                last_dt_change_1d = 0 
+
+    LOGICAL ::  run_control_header_1d = .FALSE., stop_dt_1d = .FALSE. 
+
+    REAL ::     damp_level_1d = -1.0, dt_1d = 60.0, dt_max_1d = 300.0, &
+                dt_pr_1d = 9999999.9, dt_run_control_1d = 60.0, &
+                end_time_1d = 864000.0, old_dt_1d = 1.0E-10, &
+                qs1d, simulated_time_1d = 0.0, time_pr_1d = 0.0, &
+                time_run_control_1d = 0.0, ts1d, us1d, usws1d, usws1d_m, &
+                vsws1d, vsws1d_m, z01d
+
+
+    REAL, DIMENSION(:), ALLOCATABLE ::  e1d, e1d_m, e1d_p, kh1d, kh1d_m, km1d, &
+                                        km1d_m, l_black, l1d, l1d_m, rif1d,    &
+                                        te_e, te_em, te_u, te_um, te_v, te_vm, &
+                                        u1d, u1d_m, u1d_p, v1d, v1d_m, v1d_p
+
+    SAVE
+
+ END MODULE model_1d
+
+
+
+
+ MODULE netcdf_control
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of parameters and variables for netcdf control.
+!------------------------------------------------------------------------------!
+
+#if defined( __netcdf )
+    USE netcdf
+#endif
+
+    INTEGER, PARAMETER ::  dopr_norm_num = 7, dopts_num = 26, dots_num = 22, &
+                           replace_num = 6
+
+    CHARACTER, DIMENSION( replace_num ) :: &
+                           replace_char = (/ '''', '"', '*', '/', '(', ')' /), &
+                           replace_by   = (/ 'p' , 'p', 's', 'o', '_', '_' /)
+
+    CHARACTER (LEN=6), DIMENSION(dopr_norm_num) ::  dopr_norm_names =   &
+         (/ 'wpt0  ', 'ws2   ', 'tsw2  ', 'ws3   ', 'ws2tsw', 'wstsw2', &
+            'z_i   ' /)
+
+    CHARACTER (LEN=6), DIMENSION(dopr_norm_num) ::  dopr_norm_longnames = &
+         (/ 'wpt0  ', 'w*2   ', 't*w2  ', 'w*3   ', 'w*2t*w', 'w*t*w2',   &
+            'z_i   ' /)
+
+    CHARACTER (LEN=7), DIMENSION(dopts_num) :: dopts_label = &
+          (/ 'tnpt   ', 'x_     ', 'y_     ', 'z_     ', 'z_abs  ', 'u      ', &
+             'v      ', 'w      ', 'u"     ', 'v"     ', 'w"     ', 'npt_up ', &
+             'w_up   ', 'w_down ', 'npt_max', 'npt_min', 'x*2    ', 'y*2    ', &
+             'z*2    ', 'u*2    ', 'v*2    ', 'w*2    ', 'u"2    ', 'v"2    ', &
+             'w"2    ', 'npt*2  ' /)
+
+    CHARACTER (LEN=7), DIMENSION(dopts_num) :: dopts_unit = &
+          (/ 'number ', 'm      ', 'm      ', 'm      ', 'm      ', 'm/s    ', &
+             'm/s    ', 'm/s    ', 'm/s    ', 'm/s    ', 'm/s    ', 'number ', &
+             'm/s    ', 'm/s    ', 'number ', 'number ', 'm2     ', 'm2     ', &
+             'm2     ', 'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'm2/s2  ', 'm2/s2  ', &
+             'm2/s2  ', 'number2' /)
+
+    CHARACTER (LEN=7), DIMENSION(dots_num) :: dots_label = &
+          (/ 'E      ', 'E*     ', 'dt     ', 'u*     ', 'th*    ', 'umax   ', &
+             'vmax   ', 'wmax   ', 'div_new', 'div_old', 'z_i_wpt', 'z_i_pt ', &
+             'w*     ', 'w"pt"0 ', 'w"pt"  ', 'wpt    ', 'pt(0)  ', 'pt(zp) ', &
+             'splptx ', 'splpty ', 'splptz ', 'mo_L   ' /)
+
+    CHARACTER (LEN=7), DIMENSION(dots_num) :: dots_unit = &
+          (/ 'm2/s2  ', 'm2/s2  ', 's      ', 'm/s    ', 'K      ', 'm/s    ', &
+             'm/s    ', 'm/s    ', 's-1    ', 's-1    ', 'm      ', 'm      ', &
+             'm/s    ', 'K m/s  ', 'K m/s  ', 'k m/s  ', 'K      ', 'K      ', &
+             '%      ', '%      ', '%      ', 'm      ' /)
+
+    CHARACTER (LEN=7), DIMENSION(100) ::  dopr_unit = 'unknown'
+
+    CHARACTER (LEN=7), DIMENSION(0:1,100) ::  do2d_unit, do3d_unit
+
+    CHARACTER (LEN=16), DIMENSION(25) ::  prt_var_names = &
+          (/ 'pt_age          ', 'pt_dvrp_size    ', 'pt_origin_x     ', &
+             'pt_origin_y     ', 'pt_origin_z     ', 'pt_radius       ', &
+             'pt_speed_x      ', 'pt_speed_y      ', 'pt_speed_z      ', &
+             'pt_weight_factor', 'pt_x            ', 'pt_y            ', &
+             'pt_z            ', 'pt_color        ', 'pt_group        ', &
+             'pt_tailpoints   ', 'pt_tail_id      ', 'pt_density_ratio', &
+             'pt_exp_arg      ', 'pt_exp_term     ', 'not_used        ', &
+             'not_used        ', 'not_used        ', 'not_used        ', &
+             'not_used        ' /)
+
+    CHARACTER (LEN=16), DIMENSION(25) ::  prt_var_units = &
+          (/ 'seconds         ', 'meters          ', 'meters          ', &
+             'meters          ', 'meters          ', 'meters          ', &
+             'm/s             ', 'm/s             ', 'm/s             ', &
+             'factor          ', 'meters          ', 'meters          ', &
+             'meters          ', 'none            ', 'none            ', &
+             'none            ', 'none            ', 'ratio           ', &
+             'none            ', 'none            ', 'not_used        ', &
+             'not_used        ', 'not_used        ', 'not_used        ', &
+             'not_used        ' /)
+
+    INTEGER ::  id_dim_prtnum, id_dim_time_pr, id_dim_time_prt, &
+                id_dim_time_pts, id_dim_time_sp, id_dim_time_ts, id_dim_x_sp, &
+                id_dim_y_sp, id_dim_zu_sp, id_dim_zw_sp, id_set_pr, &
+                id_set_prt, id_set_pts, id_set_sp, id_set_ts, id_var_prtnum, &
+                id_var_rnop_prt, id_var_time_pr, id_var_time_prt, &
+                id_var_time_pts, id_var_time_sp, id_var_time_ts, id_var_x_sp, &
+                id_var_y_sp, id_var_zu_sp, id_var_zw_sp, nc_stat
+
+    INTEGER, DIMENSION(0:1) ::  id_dim_time_xy, id_dim_time_xz, &
+                id_dim_time_yz, id_dim_time_3d, id_dim_x_xy, id_dim_xu_xy, &
+                id_dim_x_xz, id_dim_xu_xz, id_dim_x_yz, id_dim_xu_yz, &
+                id_dim_x_3d, id_dim_xu_3d, id_dim_y_xy, id_dim_yv_xy, &
+                id_dim_y_xz, id_dim_yv_xz, id_dim_y_yz, id_dim_yv_yz, &
+                id_dim_y_3d, id_dim_yv_3d, id_dim_zu_xy, id_dim_zu1_xy, &
+                id_dim_zu_xz, id_dim_zu_yz, id_dim_zu_3d, id_dim_zw_xy, &
+                id_dim_zw_xz, id_dim_zw_yz, id_dim_zw_3d, id_set_xy, &
+                id_set_xz, id_set_yz, id_set_3d, id_var_ind_x_yz, &
+                id_var_ind_y_xz, id_var_ind_z_xy, id_var_time_xy, &
+                id_var_time_xz, id_var_time_yz, id_var_time_3d, id_var_x_xy, &
+                id_var_xu_xy, id_var_x_xz, id_var_xu_xz, id_var_x_yz, &
+                id_var_xu_yz, id_var_x_3d, id_var_xu_3d, id_var_y_xy, &
+                id_var_yv_xy, id_var_y_xz, id_var_yv_xz, id_var_y_yz, &
+                id_var_yv_yz, id_var_y_3d, id_var_yv_3d, id_var_zu_xy, &
+                id_var_zu1_xy, id_var_zu_xz, id_var_zu_yz, id_var_zu_3d, &
+                id_var_zw_xy, id_var_zw_xz, id_var_zw_yz, id_var_zw_3d
+
+    INTEGER, DIMENSION(10)  ::  id_var_dospx, id_var_dospy, nc_precision 
+    INTEGER, DIMENSION(20)  ::  id_var_prt
+    INTEGER, DIMENSION(dopr_norm_num) ::  id_var_norm_dopr
+
+    INTEGER, DIMENSION(dopts_num,0:10) ::  id_var_dopts
+    INTEGER, DIMENSION(0:1,100)        ::  id_var_do2d, id_var_do3d
+    INTEGER, DIMENSION(100,0:9)        ::  id_dim_z_pr, id_var_dopr, &
+                                           id_var_z_pr
+    INTEGER, DIMENSION(dots_num,0:9)   ::  id_var_dots
+
+
+    SAVE
+
+ END MODULE netcdf_control
+
+
+
+ MODULE particle_attributes
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of variables used to compute particle transport
+!------------------------------------------------------------------------------!
+
+    USE array_kind
+
+    CHARACTER (LEN=15)  ::  bc_par_lr = 'cyclic',  bc_par_ns = 'cyclic', &
+                            bc_par_b  = 'reflect', bc_par_t  = 'absorb'
+
+#if defined( __parallel )
+    INTEGER ::  mpi_particle_type
+#endif
+    INTEGER ::  ibc_par_lr, ibc_par_ns, ibc_par_b, ibc_par_t,                  &
+                iran_part = -1234567, maximum_number_of_particles = 1000,      &
+                maximum_number_of_tailpoints = 100,                            &
+                maximum_number_of_tails = 0,                                   &
+                number_of_initial_particles = 0, number_of_particles = 0,      &
+                number_of_particle_groups = 1, number_of_tails = 0,            &
+                number_of_initial_tails = 0, particles_per_point = 1,          &
+                particle_file_count = 0, skip_particles_for_tail = 100,        &
+                total_number_of_particles, total_number_of_tails = 0
+
+    INTEGER, PARAMETER ::  max_number_of_particle_groups = 10
+
+    INTEGER, DIMENSION(:), ALLOCATABLE     ::  new_tail_id
+    INTEGER, DIMENSION(:,:,:), ALLOCATABLE ::  prt_count, prt_start_index
+
+    LOGICAL ::  particle_advection = .FALSE., random_start_position = .FALSE., &
+                read_particles_from_restartfile = .TRUE.,                      &
+                uniform_particles = .TRUE., use_particle_tails = .FALSE.,      &
+                use_sgs_for_particles = .FALSE.,                               &
+                vertical_particle_advection = .TRUE.,                          &
+                write_particle_statistics = .FALSE.
+    LOGICAL, DIMENSION(:), ALLOCATABLE ::  particle_mask, tail_mask
+
+    REAL    ::  c_0 = 3.0, dt_min_part = 0.0002,                               &
+                dt_write_particle_data = 9999999.9, dvrp_psize = 9999999.9,    &
+                end_time_prel = 9999999.9, initial_weighting_factor = 1.0,     &
+                maximum_tailpoint_age = 100000.0,                              &
+                minimum_tailpoint_distance = 0.0,                              &
+                particle_advection_start = 0.0, sgs_wfu_part = 0.3333333,      &
+                sgs_wfv_part = 0.3333333, sgs_wfw_part = 0.3333333,            &
+                time_write_particle_data = 0.0
+
+    REAL, DIMENSION(max_number_of_particle_groups) ::  &
+                density_ratio = 9999999.9, pdx = 9999999.9, pdy = 9999999.9, &
+                pdz = 9999999.9, psb = 9999999.9, psl = 9999999.9,           &
+                psn = 9999999.9, psr = 9999999.9, pss = 9999999.9,           &
+                pst = 9999999.9, radius = 9999999.9
+
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  particle_tail_coordinates
+
+
+    TYPE particle_type
+       SEQUENCE
+       REAL    ::  age, dt_sum, dvrp_psize, e_m, origin_x, origin_y, origin_z, &
+                   radius, speed_x, speed_x_sgs, speed_y, speed_y_sgs,         &
+                   speed_z, speed_z_sgs, weight_factor, x, y, z
+       INTEGER ::  color, group, tailpoints, tail_id
+    END TYPE particle_type
+
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  initial_particles, &
+                                                       particles
+
+    TYPE particle_groups_type
+       SEQUENCE
+       REAL    ::  density_ratio, radius, exp_arg, exp_term
+    END TYPE particle_groups_type
+
+    TYPE(particle_groups_type), DIMENSION(max_number_of_particle_groups) ::&
+                   particle_groups
+
+    SAVE
+
+ END MODULE particle_attributes
+
+
+
+
+
  MODULE pegrid
 
-    USE kinds
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of variables which define processor topology and the exchange of
+! ghost point layers. This modules must be placed in all routines which contain
+! MPI-calls.
+!------------------------------------------------------------------------------!
 
 #if defined( __parallel )
+#if defined( __lcmuk )
     USE MPI
+!    INCLUDE "mpif.h"
+#else
+    INCLUDE "mpif.h"
 #endif
-
-    CHARACTER(LEN=2) ::  send_receive = 'al'     !<
-    CHARACTER(LEN=7) ::  myid_char = ''          !< character string containing processor id number
-
-    INTEGER(iwp) ::  comm1dx                     !< communicator for domain decomposition along x
-    INTEGER(iwp) ::  comm1dy                     !< communicator for domain decomposition along y
-    INTEGER(iwp) ::  comm2d                      !< standard 2d (xy) communicator used in PALM for the process group the PE belongs
-                                                 !< to
-    INTEGER(iwp) ::  comm_inter                  !< intercommunicator that connects atmosphere/ocean process groups
-    INTEGER(iwp) ::  comm_palm                   !< internal communicator used during the MPI setup at the beginning of a run
-    INTEGER(iwp) ::  id_inflow = 0               !< myidx of procs at inflow (turbulent inflow method)
-    INTEGER(iwp) ::  id_outflow = 0              !< myidx of procs at outflow (turbulent outflow method)
-    INTEGER(iwp) ::  id_outflow_source = 0       !< myidx of procs including ouflow source plane (turbulent outflow method)
-    INTEGER(iwp) ::  id_recycling = 0            !< myidx of procs containing the recycling plane (turbulence recycling method)
-    INTEGER(iwp) ::  ierr                        !< standard error parameter in MPI calls
-    INTEGER(iwp) ::  myid = 0                    !< id number of processor element
-    INTEGER(iwp) ::  myidx = 0                   !< id number of processor elements with same position along x-direction
-    INTEGER(iwp) ::  myidy = 0                   !< id number of processor elements with same position along y-direction
-    INTEGER(iwp) ::  ndim = 2                    !< dimension of the virtual PE grid
-    INTEGER(iwp) ::  ngp_a                       !< used in atmosphere/ocean coupling: total number of horizontal grid points
-                                                 !< (atmosphere)
-    INTEGER(iwp) ::  ngp_o                       !< used in atmosphere/ocean coupling: total number of horizontal grid points
-                                                 !< (ocean)
-    INTEGER(iwp) ::  ngp_xy                      !< used in atmosphere/ocean coupling: number of grid points of the subdomain
-    INTEGER(iwp) ::  ngp_y                       !< number of subdomain grid points along y including ghost points
-    INTEGER(iwp) ::  npex = -1                   !< number of processor elements in x-direction
-    INTEGER(iwp) ::  npey = -1                   !< number of processor elements in y-direction
-    INTEGER(iwp) ::  numprocs = 1                !< total number of appointed processor elements
-    INTEGER(iwp) ::  numprocs_previous_run = -1  !< total number of appointed processor elements in previous run (job chain)
-    INTEGER(iwp) ::  pleft                       !< MPI id of left neigbour pe
-    INTEGER(iwp) ::  pnorth                      !< MPI id of right neigbour pe
-    INTEGER(iwp) ::  pright                      !< MPI id of south neigbour pe
-    INTEGER(iwp) ::  psouth                      !< MPI id of north neigbour pe
-    INTEGER(iwp) ::  req_count = 0               !< MPI return variable - checks if Send-Receive operation is already finished
-    INTEGER(iwp) ::  sendrecvcount_xy            !< number of subdomain gridpoints to be exchanged in direct transpositions
-                                                 !< (y --> x, or x --> y) or second (2d) transposition x --> y
-    INTEGER(iwp) ::  sendrecvcount_yz            !< number of subdomain gridpoints to be exchanged in third (2d) transposition
-                                                 !< y --> z
-    INTEGER(iwp) ::  sendrecvcount_zx            !< number of subdomain gridpoints to be exchanged in first (2d) transposition
-                                                 !< z --> x
-    INTEGER(iwp) ::  sendrecvcount_zyd           !< number of subdomain gridpoints to be exchanged in direct transpositions z --> y (used for calculating spectra)
-    INTEGER(iwp) ::  target_id                   !< in atmosphere/ocean coupling: id of the ocean/atmosphere counterpart PE with
-                                                 !< whom the atmosphere/ocean PE exchanges data
-    INTEGER(iwp) ::  tasks_per_node = -9999      !< MPI tasks per compute node
-    INTEGER(iwp) ::  threads_per_task = 1        !< number of OPENMP threads per MPI task
-    INTEGER(iwp) ::  type_x                      !< derived MPI datatype for 2-D ghost-point exchange - north / south
-    INTEGER(iwp) ::  type_xy                     !< derived MPI datatype for 2-D ghost-point exchange - north / south
-    INTEGER(iwp) ::  type_y                      !< derived MPI datatype for 2-D exchange in atmosphere-ocean coupler
-
-    INTEGER(iwp) ::  pdims(2) = 1  !< number of processors along x-y dimension
-    INTEGER(iwp) ::  req(100)      !< MPI return variable indicating if send-receive operation is finished
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds               !< horizontal index bounds
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds_previous_run  !< horizontal index bounds of previous run
-
-    LOGICAL ::  collective_wait = .FALSE.          !< switch to set an explicit MPI barrier in front of all collective MPI calls
-
-    TYPE virtual_pe_grid
-       INTEGER(iwp) ::  mpi_communicator         !< MPI communicator id
-       INTEGER(iwp) ::  pleft                    !< MPI id of left neigbour pe
-       INTEGER(iwp) ::  pright                   !< MPI id of right neigbour pe
-       INTEGER(iwp) ::  psouth                   !< MPI id of south neigbour pe
-       INTEGER(iwp) ::  pnorth                   !< MPI id of north neigbour pe
-    END TYPE virtual_pe_grid
-
-    TYPE(virtual_pe_grid) ::  communicator_configurations(4)  !< stores the four possible 2d virtual grids:
-                                                              !< cyclic, cyclic along x, cyclic along y, non-cyclic
+#endif
+    CHARACTER(LEN=5)       ::  myid_char = '', myid_char_14 = ''
+    INTEGER                ::  myid=0, npex = -1, npey = -1, numprocs = 1, &
+                               tasks_per_node = -9999, threads_per_task = 1
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  ibuf(12)                 !< internal buffer for calculating MPI settings
-    INTEGER(iwp) ::  pcoord(2)                !< PE coordinates along x and y
-    INTEGER(iwp) ::  status(MPI_STATUS_SIZE)  !< MPI status variable used in various MPI calls
-    INTEGER(iwp) ::  type_x_byte              !< derived MPI datatype for 2-D 8-bit integer ghost-point exchange - north / south
-    INTEGER(iwp) ::  type_y_byte              !< derived MPI datatype for 2-D integer ghost-point exchange - left / right
-
-    INTEGER(iwp), DIMENSION(MPI_STATUS_SIZE,100) ::  wait_stat  !< MPI status variable used in various MPI calls
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_xz      !< number of ghost points in xz-plane on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_xz_int  !< number of ghost points in xz-plane on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_yz      !< number of ghost points in yz-plane on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_yz_int  !< number of ghost points in yz-plane on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_x_int  !< derived MPI datatype for 2-D integer ghost-point exchange - north /
-                                                            !< south
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_xz     !< derived MPI datatype for 3-D integer ghost-point exchange - north /
-                                                            !< south
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_xz_int !< derived MPI datatype for 3-D integer ghost-point exchange - north /
-                                                            !< south
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_y_int  !< derived MPI datatype for 2-D integer ghost-point exchange - left /
-                                                            !< right
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_yz     !< derived MPI datatype for 3-D integer ghost-point exchange - left /
-                                                            !< right
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_yz_int !< derived MPI datatype for 3-D integer ghost-point exchange - left /
-                                                            !< right
-
-    LOGICAL ::  left_border_pe  = .FALSE.  !< = .TRUE. if PE is on left border of computational domain
-    LOGICAL ::  north_border_pe = .FALSE.  !< = .TRUE. if PE is on north border of computational domain
-    LOGICAL ::  reorder = .TRUE.           !< switch to allow MPI the reorder of ranking (e.g. row-major or column-major)
-    LOGICAL ::  right_border_pe = .FALSE.  !< = .TRUE. if PE is on right border of computational domain
-    LOGICAL ::  south_border_pe = .FALSE.  !< = .TRUE. if PE is on south border of computational domain
-
-    LOGICAL, DIMENSION(2) ::  cyclic = (/ .TRUE. , .TRUE. /)  !< boundary conditions of the virtual PE grid
-    LOGICAL, DIMENSION(2) ::  remain_dims                     !< internal array used to determine sub-topologies for transpositions
+    INTEGER ::  comm1dx, comm1dy, comm2d, comm_palm, ierr, myidx, myidy,       &
+                ndim = 2, ngp_y, ngp_yz_p, pleft, pnorth, pright, psouth,      &
+                sendrecvcount_xy, sendrecvcount_yz, sendrecvcount_zx,          &
+                sendrecvcount_zyd, sendrecvcount_yxd,                          &
+                type_x, type_x_int, type_xz_p, ibuf(12), pcoord(2), pdims(2),  &
+                status(MPI_STATUS_SIZE)
+
+    INTEGER, DIMENSION(:), ALLOCATABLE ::  ngp_yz, type_xz
+
+    LOGICAL ::  reorder = .TRUE.
+    LOGICAL, DIMENSION(2) ::  cyclic = (/ .TRUE. , .TRUE. /), &
+                              remain_dims
 #endif
 
@@ -1586,43 +1125,83 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of variables which control PROFIL-output.
-!--------------------------------------------------------------------------------------------------!
+
+
  MODULE profil_parameter
 
-    USE kinds
-
-    INTEGER(iwp), PARAMETER ::  crmax = 100  !< maximum number of coordinate systems for profile output
-
-    CHARACTER (LEN=27), DIMENSION(20) ::  cross_ts_profiles = &  !< time series to be plotted into one coordinate system, respectively
-                                          (/ ' E E*                      ',                        &
-                                             ' dt                        ',                        &
-                                             ' u* w*                     ',                        &
-                                             ' th*                       ',                        &
-                                             ' umax vmax wmax            ',                        &
-                                             ' div_old div_new           ',                        &
-                                             ' zi_wtheta zi_theta        ',                        &
-                                             ' w"theta"0 w"theta" wtheta ',                        &
-                                             ' theta(0) theta(zp)        ',                        &
-                                             ' splux spluy spluz         ',                        &
-                                             ' L                         ',                        &
-                                           ( '                           ', i9 = 1, 9 ) /)
-
-    CHARACTER (LEN=100), DIMENSION(crmax) ::  cross_profiles = &  !< quantities to be plotted into one coordinate system, respectively
-                                              (/ ' u v                                          ', &
-                                                 ' pt                                           ', &
-                                                 ' w"theta" w*theta* w*theta*BC wtheta wthetaBC ', &
-                                                 ' w"u" w*u* wu w"v" w*v* wv                    ', &
-                                                 ' km kh                                        ', &
-                                                 ' l                                            ', &
-                                 ( '                                              ', i9 = 1, 94 ) /)
-
-    INTEGER(iwp) ::  profile_columns = 2  !< number of coordinate systems on a profile plot per column
-    INTEGER(iwp) ::  profile_rows = 3     !< number of coordinate systems on a profile plot per row
-
-    INTEGER(iwp) ::  dopr_index(500) = 0                !< index number of respective profile quantity
-    INTEGER(iwp) ::  dopr_initial_index(500) = 0        !< index number of initial profiles to be output
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of variables which control PROFIL-output
+!------------------------------------------------------------------------------!
+
+    INTEGER, PARAMETER ::  crmax = 100
+
+    CHARACTER (LEN=10), DIMENSION(100) ::  dopr_label = ' '
+
+    CHARACTER (LEN=10), DIMENSION(crmax) ::  cross_normalized_x = ' ', &
+                                             cross_normalized_y = ' '
+
+    CHARACTER (LEN=20), DIMENSION(20) ::  cross_ts_profiles = &
+                           (/ ' E E*               ', ' dt                 ', &
+                              ' u* w*              ', ' th*                ', &
+                              ' umax vmax wmax     ', ' div_old div_new    ', &
+                              ' z_i_wpt z_i_pt     ', ' w"pt"0 w"pt" wpt   ', &
+                              ' pt(0) pt(zp)       ', ' splux spluy spluz  ', &
+                              ' L                  ',                         &
+                            ( '                    ', i9 = 1, 9 ) /)
+
+    CHARACTER (LEN=40), DIMENSION(crmax) ::  cross_xtext = &
+                           (/ 'windspeed in ms>->1         ', &
+                              'pot. temperature in K       ', &
+                              'heat flux in K ms>->1       ', &
+                              'momentum flux in m>2s>2     ', &
+                              'eddy diffusivity in m>2s>->1', &
+                              'mixing length in m          ', &
+                            ( '                            ', i9 = 1, 94 ) /)
+
+    CHARACTER (LEN=100), DIMENSION(crmax) ::  cross_profiles = &
+                           (/ ' u v                           ', &
+                              ' pt                            ', &
+                              ' w"pt" w*pt* w*pt*BC wpt wptBC ', &
+                              ' w"u" w*u* wu w"v" w*v* wv     ', &
+                              ' km kh                         ', &
+                              ' l                             ', &
+                         ( '                               ', i9 = 1, 94 ) /)
+
+    INTEGER ::  profile_columns = 3, profile_rows = 2, profile_number = 0
+
+    INTEGER ::  cross_linecolors(100,crmax) = 1, &
+                cross_linestyles(100,crmax) = 0, &
+                cross_profile_numbers(100,crmax) = 0, &
+                cross_pnc_local(crmax), cross_profile_number_count(crmax) = 0, &
+                cross_ts_numbers(crmax,crmax) = 0, &
+                cross_ts_number_count(crmax) = 0, dopr_crossindex(100) = 0, &
+                dopr_index(100) = 0, dopr_initial_index(100) = 0, &
+                dots_crossindex(100) = 0, dots_index(100) = 0, &
+                linecolors(10) = (/ 2, 3, 4,  5, 7, 8, 12, 15, 16, 23 /), &
+                linestyles(11) = (/ 0, 7, 3, 10, 4, 1,  9,  2,  5,  8, 6 /)
+                
+
+    REAL ::  cross_normx_factor(100,crmax) = 1.0, &
+             cross_normy_factor(100,crmax) = 1.0, &
+             cross_ts_uymax(20) = &
+                             (/ 999.999, 999.999, 999.999, 999.999, 999.999,   &
+                                999.999, 999.999, 999.999, 999.999, 999.999,   &
+                                999.999, 999.999, 999.999, 999.999, 999.999,   &
+                                999.999, 999.999, 999.999, 999.999, 999.999 /),&
+             cross_ts_uymax_computed(20) = 999.999, &
+             cross_ts_uymin(20) = &
+                             (/ 999.999, 999.999, 999.999,  -5.000, 999.999,   &
+                                999.999,   0.000, 999.999, 999.999, 999.999,   &
+                                999.999, 999.999, 999.999, 999.999, 999.999,   &
+                                999.999, 999.999, 999.999, 999.999, 999.999 /),&
+             cross_ts_uymin_computed(20) = 999.999, &
+             cross_uxmax(crmax) = 0.0, cross_uxmax_computed(crmax) = -1.0, &
+             cross_uxmax_normalized(crmax) = 0.0, &
+             cross_uxmax_normalized_computed(crmax) = -1.0, &
+             cross_uxmin(crmax) = 0.0, cross_uxmin_computed(crmax) =  1.0, &
+             cross_uxmin_normalized(crmax) = 0.0, &
+             cross_uxmin_normalized_computed(crmax) = 1.0, &
+             cross_uymax(crmax), cross_uymin(crmax)
 
     SAVE
